import React from 'react';
import {connect} from 'react-redux';
import VideoPlayer from "../components/VideoPlayer";

class Video extends React.Component {

  getInitialState() {
    return {
      currentVideo: null
    };
  }

  componentDidMount() {
    // get videoId from the URL
    const videoId = this.props.match.params.id;

    // if data for videoId is already part of allVideos, setState to currentVideo
    if (this.props.allVideos.hasOwnProperty(videoId)) {
      const currentVideo = this.props.allVideos[videoId];
      this.setState({'currentVideo': currentVideo});
    } else {
      // TODO: get video data if not available in cache
    }
  }

  render() {
    const video = this.state.currentVideo;
    return (
      <section>
        { video && 
          <VideoPlayer 
            id={ video.id }
            title={ video.title }
            date = { video.date }
            description={ video.description }
          /> 
        }
      </section>
    );
  }
}

const mapStateToProps = state => {
  allVideos: this.state.allVideos; 
};

export default connect(mapStateToProps)(Video);